OpenVDB 7.0.0

Public Types | Public Member Functions | List of all members
DiffuseShader< GridT, SamplerType > Class Template Reference

Simple diffuse Lambertian surface shader. More...

`#include <RayTracer.h>`

Inherits BaseShader.

## Public Types
using | RayT = math::Ray< Real >

## Public Member Functions
| DiffuseShader (const GridT &grid)
| DiffuseShader (const DiffuseShader &)=default
| ~DiffuseShader () override=default
Film::RGBA | operator() (const Vec3R &xyz, const Vec3R &normal, const Vec3R &rayDir) const override
| Defines the interface of the virtual function that returns a RGB color. More...
BaseShader * | copy () const override

## Detailed Description

### template<typename GridT = Film::RGBA, typename SamplerType = tools::PointSampler>
class openvdb::v7_0::tools::DiffuseShader< GridT, SamplerType >

Simple diffuse Lambertian surface shader.

The diffuse color can either be constant (if GridT = Film::RGBA which is the default) or defined in a separate Vec3 color grid. Lambertian implies that the (radiant) intensity is directly proportional to the cosine of the angle between the surface normal and the direction of the light source. Use SamplerType to define the order of interpolation (default is zero order, i.e. closes-point).

## Member Typedef Documentation

## ◆ RayT

using RayT = math::Ray<Real>
| inherited

## Constructor & Destructor Documentation

## ◆ DiffuseShader() [1/2]

DiffuseShader | ( | const GridT & | grid | ) |
| inline

## ◆ DiffuseShader() [2/2]

DiffuseShader | ( | const DiffuseShader< GridT, SamplerType > & |  | ) |
| default

## ◆ ~DiffuseShader()

~DiffuseShader | ( |  | ) |
| override default

## Member Function Documentation

## ◆ copy()

BaseShader* copy | ( |  | ) | const
| inline override virtual

Implements BaseShader.

## ◆ operator()()

Film::RGBA operator() | ( | const Vec3R & | xyz,
|  | const Vec3R & | nml,
|  | const Vec3R & | dir
| ) |  | const
| inline override virtual

Defines the interface of the virtual function that returns a RGB color.

Parameters

  xyz | World position of the intersection point.
  nml | Normal in world space at the intersection point.
  dir | Direction of the ray in world space.

Implements BaseShader.

The documentation for this class was generated from the following file:

- RayTracer.h